#include <iostream>

using namespace std;



int SLEDECA_KOMB (int a[],int k,int n)
{
    int i=k-1;
    while (i>=0 && a[i]==(n-k+i+1))
    {
        i--;
    }
    if (i<0)
    {
        return 0;
    }
    a[i]=a[i]+1;
    for (i=i+1;i<k;i++)
    {
        a[i]=a[i-1]+1;
    }
    return 1;
}




int main()
{
    int n,k;
    cin>>n>>k;
    int a[n];
    for (int i=0;i<n;i++)
    {
        cin>>a[i];
    }
    int pocetni,krajnji;
    pocetni=0;
    krajnji=n-1;
    if (n==k)
    {
        while (krajnji-pocetni!=1)
        {
            if (a[pocetni]>a[krajnji])
            {
                a[krajnji]=a[krajnji]-a[pocetni];
                pocetni++;
            }
            else
            {
                a[pocetni]=a[pocetni]-a[krajnji];
                krajnji--;
            }
        }
        if (a[pocetni]<a[krajnji])
        {
            a[krajnji]=a[krajnji]-a[pocetni];
            pocetni++;
        }
        else
        {
            a[pocetni]=a[pocetni]-a[krajnji];
            krajnji--;
        }
        cout<<a[pocetni];
        return 0;
    }
    int p[k];
    for (int i=0;i<k;i++)
    {
        p[i]=i+1;
    }
    int maks=0;
    do
    {
        int napitci[k];
        for (int i=0;i<k;i++)
        {
            napitci[i]=a[p[i]-1];
        }
        pocetni=0;
        krajnji=k-1;
        while (krajnji-pocetni!=1)
        {
            if (napitci[pocetni]>napitci[krajnji])
            {
                napitci[krajnji]=napitci[krajnji]-napitci[pocetni];
                pocetni++;
            }
            else
            {
                napitci[pocetni]=napitci[pocetni]-napitci[krajnji];
                krajnji--;
            }
        }
        if (napitci[pocetni]<napitci[krajnji])
        {
            napitci[krajnji]=napitci[krajnji]-napitci[pocetni];
            pocetni++;
        }
        else
        {
            napitci[pocetni]=napitci[pocetni]-napitci[krajnji];
            krajnji--;
        }

        //cout<<napitci[pocetni]<<endl;
        if (napitci[pocetni]>maks) maks=napitci[pocetni];
        //cout<<endl;
    } while (SLEDECA_KOMB(p,k,n));

    cout<<maks<<endl;
}